/* Configuring multi host using slip */
/* first configure slip.cfg in mptn/etc as follows:

'interface sl0 { device="com2" }'
'interface sl1 { device="com2" }'
'interface sl2 { device="com2" }'
'interface sl3 { device="com2" }'
'interface sl4 { device="com2" }'

*/
/* Do the setup.cmd bit */
'route -fh'
'arp -f'
'ifconfig lan0 194.70.219.42 netmask 255.255.255.0'
/* Do the setup.cmd bit */
'route add default 194.70.219.65 1'
'ipgate on'

/* Configure the loopback interface (if not already done */
'ifconfig lo 194.70.219.191'

/* then start slip */
/* 'start slip' */

/* Now configure the slip interfaces */
'ifconfig sl0 194.70.219.192  194.70.219.191'
'route delete 194.70.219.191 194.70.219.192' /* delete spurious route */

/* Now publish the ip address on ethernet */
'arp -s 194.70.219.191 00:80:c6:FF:09:97 pub'
'arp -s 194.70.219.192 00:80:c6:FF:09:97 pub'

/* and now add the appropriate routes */
'route add host 194.70.219.192 194.70.219.191 0'


/* slip can now be cancelled */
'netstat -r'
'arp -a'
